/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/main.cpp

    Copyright © 2014, 2016—2018 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

/**
    @file
    `main` function is defined here.
**/

#include "config.h"

#include "app.hpp"
#include "ui.hpp"

#include <exception>

int
main(
    int     argc,
    char *  argv[]
) {
    int status = 0;
    try {
        app_t app( argc, argv );
    } catch ( std::exception const & ex ) {
        msg( sl_error, ex.what() );
        status = 1;
    } catch ( ... ) {
        msg( sl_error, "Unknown exception occurred" );
        status = 2;
    }; // try
    return status;
}; // main

// end of file //
