/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/tapper.hpp

    Copyright © 2014, 2016—2018 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

#ifndef _TAPPER_HPP_
#define _TAPPER_HPP_

#include "base.hpp"

#include "x.hpp"

// -------------------------------------------------------------------------------------------------
// tapper_t
// -------------------------------------------------------------------------------------------------

class tapper_t : public object_t {

    public :

        explicit tapper_t( x::kb_t & kb );
        virtual ~tapper_t();
        void start();
        void stop();

    protected :

        /**
            Tap handler. It is called when tap is detected.
        **/
        virtual void on_tap( KeyCode key_code ) = 0;

        x::kb_t & _kb;

    private :

        class interceptor_t;
        typedef ptr_t< interceptor_t > interceptor_p;

        interceptor_p                  interceptor;
        x::kb_t::autorepeat_rate_t     autorepeat_rate;

}; // class tapper_t

#endif // _TAPPER_HPP_

// end of file //
