/*
    ---------------------------------------------------------------------- copyright and license ---

    file: src/ui.cpp

    Copyright © 2014, 2016—2018 Van de Bugger.

    This file is a part of Tapper.

    Tapper is free software: you can redistribute it and/or modify it under the terms of the GNU
    General Public License as published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    Tapper is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
    even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License along with Tapper.  If not,
    see <http://www.gnu.org/licenses/>.

    SPDX-License-Identifier: GPL-3.0-or-later

    ---------------------------------------------------------------------- copyright and license ---
*/

/**
    @file
    User interface implementation.
**/

#include "ui.hpp"

#include <iostream>

#include "base.hpp"

void msg( severity_level_t level, string_t const & message ) {
    string_t prefix = "?";
    switch ( level ) {
        case sl_error : {
            prefix = "E";
        } break;
        case sl_warning : {
            prefix = "W";
        } break;
        case sl_info : {
            prefix = "I";
        } break;
        case sl_debug : {
            prefix = "#";
        } break;
    };
    std::cerr << STR( program_invocation_short_name << ": " << prefix << " " << message << "\n" );
}; // msg

// end of file //
